"use strict";

exports.sigBytes = Buffer.from([0x0D, 0x0A, 0x0D, 0x0A, 0x00, 0x0D, 0x0A, 0x51, 0x55, 0x49, 0x54, 0x0A]);

exports.V2_PROXY = 0x20;

exports.fields = {
	sig:     0x00,
	ver_cmd: 0x0c,
	family:  0x0d,
	len:     0x0e,
	addr:    0x10
};

exports.ipv4Addr = {
	src_addr:  0x00,
	dst_addr:  0x04,
	src_port:  0x08,
	dst_port:  0x0a,
	len:       0x0c
};

exports.ipv6Addr = {
	src_addr:  0x00,
	dst_addr:  0x10,
	src_port:  0x20,
	dst_port:  0x22,
	len:       0x24
};

exports.unixAddr = {
	src_addr:  0x00,
	dst_addr:  0x6c,
	len:       0xd8
};

exports.families = {
	AF_UNSPEC: 0x00,
	AF_INET:   0x10,
	AF_INET6:  0x20,
	AF_UNIX:   0x30
};

exports.protocols = {
	UNSPEC: 0x00,
	STREAM: 0x01,
	DGRAM:  0x02
};

